package com.bea.dsp.wrappers.excel;

//import org.w3c.dom.*;
//import org.apache.xerces.dom.DocumentImpl;
import java.io.IOException;
import java.util.Timer;
import java.util.TimerTask;

import com.bea.excel.ExcelDocument;
import com.bea.dsp.wrappers.excel.jcom.*;

public class Excel_JCOM extends TimerTask /* don't do this here implements weblogic.common.T3ShutdownDef */ {
	  public Excel_JCOM() {
	  }

	/*
		public String shutdown(String name, java.util.Hashtable ht){
			if (app != null){
				try
				{
						app.quit();		
				}
				catch (IOException ioe)
				{
					ioe.printStackTrace();
				}

				app=null;
				com.linar.jintegra.Cleaner.releaseAll();
			}
			return "Shutting down Excel";
		}

		public void setServices(weblogic.common.T3ServicesDef t3services){
		}
	*/

	    public void run()
	    {
		if(app != null){
			try{
				app.getDefaultFilePath();
			} catch (IOException ioe){
				System.out.println("getExcel() caught IOException in run()");
				app=null;
				//keepAliveTimer.cancel();
				com.linar.jintegra.Cleaner.releaseAll();
			}
		}

	    }


	    static Excel_JCOM theInstance=new Excel_JCOM();
	    static Timer keepAliveTimer;



	 static Application app     = null;

	 public static ExcelDocument.Excel getExcel(String fileName, String sheetName)
		{

		ExcelDocument.Excel excelElement=null;

		System.out.println("getExcel: fileName="+fileName+" sheetName="+ sheetName);

		if(app != null){
	      		try {
				app.getDefaultFilePath();
				}catch (IOException ioe){
					System.out.println("getExcel() caught SocketException in getExcel()");
					app=null;
					com.linar.jintegra.Cleaner.releaseAll();
			}
		}


	    try {
	      // Create an instance of Excel.Application.
		  if (app==null)
		  {
		       com.bea.jcom.Jvm.register("java2");
		       //com.linar.jintegra.Log.logImmediately(3,"c:\\jcom.log");
		      app     = new Application();
		      app.setDefaultFilePath( System.getProperty("user.dir")+"\\"+"excel" );
		      System.out.println("getExcel:"+
			  " filePath="+app.getDefaultFilePath());

			if(keepAliveTimer==null){
		        	keepAliveTimer=new Timer(true);
				keepAliveTimer.scheduleAtFixedRate(theInstance, 10*1000, 10*1000);
			}
		  }


	      Workbooks workbooks = app.getWorkbooks();
	      Workbook workbook   =  
	    	  
	    	  workbooks.open(fileName, null, null, null, null, null, null, null, null, null, null, null, null, null, null);
	    	  
	    	  /* open(filename, 
	    	   * updateLinks, 
	    	   * readOnly, 
	    	   * format, 
	    	   * password, 
	    	   * writeResPassword, 
	    	   * ignoreReadOnlyRecommended, 
	    	   * origin, 
	    	   * delimiter,
	    	   * editable, 
	    	   * zz_notify, 
	    	   * converter, 
	    	   * addToMru, local, 
	    	   * corruptLoad) */
	    	  
	    	  /*workbooks.open  (
	              fileName,
	              null,
	              null,
	              null,
	              null,
	              null,
	              null,
	              null,
	              null,
	              null,
	              null,
	              null,
	              null);
	              */
	/*
			   public Workbook open  (
	              String filename,
	              Object updateLinks,
	              Object readOnly,
	              Object format,
	              Object password,
	              Object writeResPassword,
	              Object ignoreReadOnlyRecommended,
	              Object origin,
	              Object delimiter,
	              Object editable,
	              Object zz_notify,
	              Object converter,
	              Object addToMru) throws java.io.IOException, com.linar.jintegra.AutomationException;

	*/

	      Sheets worksheets   = workbook.getWorksheets();
	      Worksheet sheet     = null;
		  
		
		  for(int idx=1; idx<= worksheets.getCount(); idx++){
	  		  sheet = new Worksheet(worksheets.getItem(new Integer(idx)));
			  if (sheet.getName().equals(sheetName) )
				  break;
		  }

		  if(!sheet.getName().equals(sheetName)){
	  		  System.out.println("Excel JF: sheet not found '"+sheetName+"'");
			  return null;
		  }

	      Range range         = sheet.getUsedRange(); 

	      Object[][] values = (Object[][])range.getValue(null);

		  ExcelDocument doc=ExcelDocument.Factory.newInstance();

	      excelElement=doc.addNewExcel();
		  ExcelDocument.Excel.Cells cells=excelElement.addNewCells();

	      for(int i = 0; i < values.length; i++) {
			ExcelDocument.Excel.Row row=excelElement.addNewRow();
			String rowNumber=""+(i+1);
			row.setRowNumber(new java.math.BigDecimal(i+1));
			row.setRowID(padRowNumber(rowNumber));

			for(int j = 0; j < values[i].length; j++) {
				ExcelDocument.Excel.Row.Col col=row.addNewCol();
				String colName=convertColumnName(j+1);
				col.setColumnName(colName);
				col.setColumnID(padColumnName(colName));

				ExcelDocument.Excel.Cells.Cell cell=cells.addNewCell();
				cell.setCellID(padColumnName(colName)+":"+padRowNumber(rowNumber));

				if(values[i][j] != null){
				  col.setStringValue( (values[i][j]).toString() );
				  cell.setStringValue( (values[i][j]).toString() );
				}
	        }
	      }

	      // False means don't prompt to save changes
	      workbook.close(new Boolean(false), null, null); 

		  if(false){
			 app.quit();
			 app=null;
		  }

	    } catch(Exception e) {
	      e.printStackTrace();
	    } finally {
	      // Release all remote objects that haven't already been garbage collected.
		  // if(false)
			// com.linar.jintegra.Cleaner.releaseAll();
	    }

	    return excelElement;
	  }

	private static String convertColumnName(int num){

		StringBuffer sb=new StringBuffer();

		num=num-1;
		while(num > 25 ) {
			sb.append((char) (num%26+65));
			num = num / 26 - 1;
		}
		sb.append((char) (num%26+65));
		return sb.reverse().toString();
	}

	private static String padColumnName(String name){

		StringBuffer sb=new StringBuffer(4);
		for(int i=0; i<4-name.length(); i++)
			sb.append("A");
		sb.append(name);
		return sb.toString();
	}


	private static String padRowNumber(String name){

		StringBuffer sb=new StringBuffer(4);
		for(int i=0; i<4-name.length(); i++)
			sb.append("0");
		sb.append(name);
		return sb.toString();
	}


	public static void main(String args[]){

		System.out.println( getExcel("test.xls", "Customers")  );

	}

	}
